【转】HDU1028

转自博客园ID:2108,老卢同志

http://www.cnblogs.com/--ZHIYUAN/p/6102893.html

Ignatius and the Princess III

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 19589    Accepted Submission(s): 13709

Problem Description

"Well, it seems the first problem is too easy. I will let you know how foolish you are later." feng5166 says.
"The second problem is, given an positive integer N, we define an equation like this:
  N=a[1]+a[2]+a[3]+...+a[m];
  a[i]>0,1<=m<=N;
My question is how many different equations you can find for a given N.
For example, assume N is 4, we can find:
  4 = 4;
  4 = 3 + 1;
  4 = 2 + 2;
  4 = 2 + 1 + 1;
  4 = 1 + 1 + 1 + 1;
so the result is 5 when N is 4. Note that "4 = 3 + 1" and "4 = 1 + 3" is the same in this problem. Now, you do it!"

Input

The input contains several test cases. Each test case contains a positive integer N(1<=N<=120) which is mentioned above. The input is terminated by the end of file.

Output

For each test case, you have to output a line contains an integer P which indicate the different equations you have found.

Sample Input

4 10 20

Sample Output

5 42 627

Author

Ignatius.L

题意:

拆数共有多少总方案

代码:

/*//整数拆分模板
#include <iostream>
using namespace std;
const int lmax=10000;
//c1是用来存放展开式的系数的,而c2则是用来计算时保存的,
//他是用下标来控制每一项的位置,比如 c2[3] 就是 x^3 的系数。
//用c1保存,然后在计算时用c2来保存变化的值。
int c1[lmax+1],c2[lmax+1];
int main()
{
            int n, i, j, k ;
           // 计算的方法还是模拟手动运算,一个括号一个括号的计算,
           // 从前往后
           while ( cin>>n )

          {
                     //对于 1+x+x^2+x^3+ 他们所有的系数都是 1
                     // 而 c2全部被初始化为0是因为以后要用到 c2[i] += x ;
                     for ( i=0; i<=n; i++ )

                     {
                                c1[i]=1;
                                c2[i]=0;
                     }
                      //第一层循环是一共有 n 个小括号,而刚才已经算过一个了
                      //所以是从2 到 n
                     for (i=2; i<=n; i++)

                   {
                                 // 第二层循环是把每一个小括号里面的每一项,都要与前一个
                                 //小括号里面的每一项计算。
                                for ( j=0; j<=n; j++ )
                                 //第三层小括号是要控制每一项里面 X 增加的比例
                                 // 这就是为什么要用 k+= i ;
                                         for ( k=0; k+j<=n; k+=i )

                                        {
                                                 // 合并同类项,他们的系数要加在一起,所以是加法,呵呵。
                                                 // 刚开始看的时候就卡在这里了。
                                                 c2[ j+k] += c1[ j];
                                         }
                               // 刷新一下数据,继续下一次计算,就是下一个括号里面的每一项。
                              for ( j=0; j<=n; j++ )

                              {
                                          c1[j] = c2[j] ;
                                          c2[j] = 0 ;
                              }
                   }
                    cout<<c1[n]<<endl;
        }
         return 0;
}
#include<bits\stdc++.h>
using namespace std;
int c1[123],c2[123];
void solve()
{
    for(int i=0;i<=120;i++)
    {
        c1[i]=1;
        c2[i]=0;
    }
    for(int k=2;k<=120;k++)
    {
        for(int i=0;i<=120;i++)
        for(int j=0;j+i<=120;j+=k)
        c2[j+i]+=c1[i];
        for(int i=0;i<=120;i++)
        {
            c1[i]=c2[i];
            c2[i]=0;
        }
    }
}
int main()
{
    int n;
    solve();
    while(scanf("%d",&n)!=EOF)
    {
        printf("%d\n",c1[n]);
    }
    return 0;
}
时间: 2024-11-01 01:20:28

【转】HDU1028的相关文章

HDU1028 Ignatius and the Princess III 【母函数模板题】

Ignatius and the Princess III Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 12521    Accepted Submission(s): 8838 Problem Description "Well, it seems the first problem is too easy. I will let

hdu-1028

一.递归 构造一个函数fun(int n,int m); n表示输入的N,m表示组成N中的任意一个小项不超过m: 4 = 4;  4 = 3 + 1;  4 = 2 + 2;  4 = 2 + 1 + 1;  4 = 1 + 1 + 1 + 1; 分情况 1 m>n  例:fun(4,6)=fun(4,4); fun(n,m)=fun(n,n); 2 m=n 例: fun(4,4)=1+fun(4,3):  要么小项中有4(此时只有一种情况),要么没有: fun(n,m)=1+fun(n,m-1

hdu1028

#include<stdio.h>#include<string.h>const int MAXN=130;int dp[MAXN][MAXN];//dp[i][j]表示 i 表示成最大的数不超过 j 的方法数int calc(int n,int m){ if(dp[n][m]!=-1) return dp[n][m]; if(n<1||m<1) return dp[n][m]=0; if(n==1||m==1) return dp[n][m]=1; if(n<m

HDU1028 Ignatius and the Princess III【母函数】【完全背包】

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1028 题目大意: 给定正整数N,定义N = a[1] + a[2] + a[3] + - + a[m],a[i] > 0,1 <= m <= N. 对于给定的正整数N,问:能够找出多少种这样的等式? 思路: 对于N = 4, 4 = 4: 4 = 3 + 1: 4 = 2 + 2: 4 = 2 + 1 + 1: 4 = 1 + 1 + 1 + 1. 共有5种.N=4时,结果就是5.其实就是

【母函数】hdu1028 Ignatius and the Princess III

大意是给你1个整数n,问你能拆成多少种正整数组合.比如4有5种: 4 = 4;  4 = 3 + 1;  4 = 2 + 2;  4 = 2 + 1 + 1;  4 = 1 + 1 + 1 + 1; 然后就是母函数模板题--小于n的正整数每种都有无限多个可以取用. (1+x+x^2+...)(1+x^2+x^4+...)...(1+x^n+...) 答案就是x^n的系数. #include<cstdio> #include<cstring> using namespace std;

hdu1028 划分数

题意是将一个整数N划分成不超过N个整数的和, 我们定义d[i][j]为j划分成不超过i个整数的和的方案数, 那么d[i][j] = d[i][j-i](全大于0) + d[i-1][j](不全大于0). 答案就是d[N][N], 代码如下: #include <iostream> #include <algorithm> using namespace std; typedef long long LL; LL d[150][150]; int main() { d[0][0] =

hdu1028:整数拆分

求整数的拆分数.. 一种解法是母函数 #include <iostream> #include <stdio.h> #include<string.h> #include<algorithm> #include<string> #include<ctype.h> using namespace std; #define MAXN 10000 int dp[2][130]; int main() { int n; while(scanf

hdu1028 Ignatius and the Princess III

题目地址:http://acm.hdu.edu.cn/showproblem.php?pid=1028 递归能跑... 但是我交了直接超时了,然后我就把数据跑出来了再交的,等的时间有点长(怪不得超时). 过的有点猥琐,看别人代码用母函数过的. 1 #include<iostream> 2 #include<string.h> 3 #include<math.h> 4 #include<stdlib.h> 5 #include<stdio.h> 6

ACM学习历程—HDU1028 Ignatius and the Princess(组合数学)

Ignatius and the Princess Description "Well, it seems the first problem is too easy. I will let you know how foolish you are later." feng5166 says.        "The second problem is, given an positive integer N, we define an equation like this: